###nonref

= Ruby FAQ

(1) ((<一般的な質問|FAQ::一般的な質問>))
(2) ((<変数、定数、引数|FAQ::変数、定数、引数>))
(3) ((<ブロック付きメソッド呼び出し|FAQ::ブロック付きメソッド呼び出し>))（((<イテレータ|FAQ::イテレータ>))）
(4) ((<構文|FAQ::構文>))
(5) ((<メソッド|FAQ::メソッド>))
(6) ((<クラス、モジュール|FAQ::クラス、モジュール>))
(7) ((<組み込みライブラリ|FAQ::組み込みライブラリ>))
(8) ((<拡張ライブラリ|FAQ::拡張ライブラリ>))
(9) ((<ドキュメントされていない機能|FAQ::ドキュメントされていない機能>))
(10) ((<日本語の取り扱い|FAQ::日本語の取り扱い>))
(11) ((<Rubyの処理系について|FAQ::Rubyの処理系について>))

== 一般的な質問

* ((<FAQ::一般的な質問/1.1 Rubyとは何ですか>))
* ((<FAQ::一般的な質問/1.2 名前の由来を教えてください>))
* ((<FAQ::一般的な質問/1.3 Rubyの歴史を教えてください>))
* ((<FAQ::一般的な質問/1.4 どこで手に入りますか>))
* ((<FAQ::一般的な質問/1.5 Rubyのホームページを教えてください>))
* ((<FAQ::一般的な質問/1.6 Rubyのメーリングリストはありますか>))
* ((<FAQ::一般的な質問/1.7 メイリングリストの過去メールを調べたいのですが>))
* ((<FAQ::一般的な質問/1.8 rubyistとruby hackerの違いは>))
* ((<FAQ::一般的な質問/1.9 "Ruby"と"ruby"はどっちが正しいのですか>))
* ((<FAQ::一般的な質問/1.10 Rubyの参考書を教えてください>))
* ((<FAQ::一般的な質問/1.11 マニュアルを読んでも理解できないところがあるのですが>))
* ((<FAQ::一般的な質問/1.12 Ruby のキャラクターは羊？>))
* ((<FAQ::一般的な質問/1.13 バグ報告はどこへ行えばよいでしょう？>))

== 変数、定数、引数

* ((<FAQ::変数、定数、引数/2.1 変数や定数への代入によりオブジェクトはコピーされますか>))
* ((<FAQ::変数、定数、引数/2.2 ローカル変数のスコープはどのように決められていますか>))
* ((<FAQ::変数、定数、引数/2.3 ローカル変数はいつ参照可能になるのでしょうか>))
* ((<FAQ::変数、定数、引数/2.4 定数のスコープはどのように決められていますか>))
* ((<FAQ::変数、定数、引数/2.5 実引数は仮引数にどのように渡されますか>))
* ((<FAQ::変数、定数、引数/2.6 仮引数に代入すると実引数に影響を及ぼしますか>))
* ((<FAQ::変数、定数、引数/2.7 仮引数の指すオブジェクトにメッセージを送るとどうなりますか>))
* ((<FAQ::変数、定数、引数/2.8 (({*}))がついた引数は何ですか>))
* ((<FAQ::変数、定数、引数/2.9 (({&}))がついた引数は何ですか>))
* ((<FAQ::変数、定数、引数/2.10 仮引数にデフォルト値を指定できますか>))
* ((<FAQ::変数、定数、引数/2.11 ブロックに引数を渡すにはどうしますか>))
* ((<FAQ::変数、定数、引数/2.12 変数や定数の値が知らないうちに変化することがありますが>))
* ((<FAQ::変数、定数、引数/2.13 定数は変更されませんか>))

== ブロック付きメソッド呼び出し

* ((<FAQ::ブロック付きメソッド呼び出し/3.1 ブロック付きメソッド呼び出しとは何ですか>))
* ((<FAQ::ブロック付きメソッド呼び出し/3.2 ブロック付きメソッド呼び出しにブロックを渡すにはどうすればいいですか>))
* ((<FAQ::ブロック付きメソッド呼び出し/3.3 ブロックは呼び出したメソッドの中からどのように使われますか>))
* ((<FAQ::ブロック付きメソッド呼び出し/3.4 (({Proc.new}))では手続きオブジェクトが作られませんが>))

== 構文

* ((<FAQ::構文/4.1 (({:exit}))等の(({:}))のついた識別子は何ですか>))
* ((<FAQ::構文/4.2 シンボルと同名の変数の値を取り出すにはどうすればいいですか>))
* ((<FAQ::構文/4.3 (({loop}))は制御構造ですか>))
* ((<FAQ::構文/4.4 (({a +b}))がエラーになりますが>))
* ((<FAQ::構文/4.5 (({s = "x"; puts s *10})) がエラーになりますが>))
* ((<FAQ::構文/4.6 (({p {}}))で何も表示されません>))
* ((<FAQ::構文/4.7 pos=() という setter メソッドがあるのに、pos = 1 としてもなにも起こっていないように見える>))
* ((<FAQ::構文/4.8 (({'\1'}))と(({'\\1'}))はどう違いますか>))
* ((<FAQ::構文/4.9 (({p true or true and false}))は(({true}))を表示するのに、(({a=true if true or true and false}))では、(({a}))に(({true}))が代入されません。>))
* ((<FAQ::構文/4.10 (({p(nil || "")})) はなんでもないのに、 (({p(nil or "")})) はパースエラーだと言われます>))

== メソッド

* ((<FAQ::メソッド/5.1 オブジェクトにメッセージを送った時に実行されるメソッドはどのように捜されますか>))
* ((<FAQ::メソッド/5.2 (({+}))や(({-}))は演算子ですか>))
* ((<FAQ::メソッド/5.3 関数はありますか>))
* ((<FAQ::メソッド/5.4 オブジェクトのインスタンス変数を外から参照できますか>))
* ((<FAQ::メソッド/5.5 (({private}))と(({protected}))の違いが分かりません>))
* ((<FAQ::メソッド/5.6 インスタンス変数をpublicにしたいのですが>))
* ((<FAQ::メソッド/5.7 メソッドの可視性を指定したいのですが>))
* ((<FAQ::メソッド/5.8 メソッド名に大文字で始まる識別子は使えますか>))
* ((<FAQ::メソッド/5.9 (({super}))が(({ArgumentError}))になりますが>))
* ((<FAQ::メソッド/5.10 2段階上の同名のメソッドを呼びたいのですが>))
* ((<FAQ::メソッド/5.11 組み込み関数を再定義した時に、元の関数を呼びたい時はどうしますか>))
* ((<FAQ::メソッド/5.12 破壊的メソッドとは何ですか>))
* ((<FAQ::メソッド/5.13 副作用が起こるのはどんな時ですか>))
* ((<FAQ::メソッド/5.14 メソッドから複数の戻り値を返すことはできますか>))
* ((<FAQ::メソッド/5.15 今実行中のメソッドの名前を知りたいのですが>))

== クラス、モジュール

* ((<FAQ::クラス、モジュール/6.1 クラス定義は、一度に行わなければなりませんか>))
* ((<FAQ::クラス、モジュール/6.2 クラス変数はありますか>))
* ((<FAQ::クラス、モジュール/6.3 クラスのインスタンス変数とは何ですか>))
* ((<FAQ::クラス、モジュール/6.4 特異メソッドとは何ですか>))
* ((<FAQ::クラス、モジュール/6.5 クラスメソッドはありますか>))
* ((<FAQ::クラス、モジュール/6.6 特異クラスとは何ですか>))
* ((<FAQ::クラス、モジュール/6.7 モジュール関数とは何ですか>))
* ((<FAQ::クラス、モジュール/6.8 クラスとモジュールの違いは何ですか>))
* ((<FAQ::クラス、モジュール/6.9 モジュールはサブクラスを作りますか>))
* ((<FAQ::クラス、モジュール/6.10 クラス定義の中でクラスメソッドを定義するのと、トップレベルでクラスメソッドを定義する違いは何ですか>))
* ((<FAQ::クラス、モジュール/6.11 (({load}))と(({require}))はどう違いますか>))
* ((<FAQ::クラス、モジュール/6.12 (({include}))と(({extend}))はどう違いますか>))
* ((<FAQ::クラス、モジュール/6.13 (({self})) というのは何ですか>))
* ((<FAQ::クラス、モジュール/6.14 (({MatchData})) の (({begin}))、(({end})) は何を返しますか>))
* ((<FAQ::クラス、モジュール/6.15 クラス名からクラスを得ることはできますか>))

== 組み込みライブラリ

* ((<FAQ::組み込みライブラリ/7.1 (({instance_methods(true)}))は何を返しますか>))
* ((<FAQ::組み込みライブラリ/7.2 (({rand}))がいつも同じ乱数列を出しますが>))
* ((<FAQ::組み込みライブラリ/7.3 0から51の中から重複のない5つをランダムに選ぶにはどうしますか>))
* ((<FAQ::組み込みライブラリ/7.4 (({Fixnum}))、(({Symbol}))、(({true}))、(({nil}))、(({false}))が即値だということですが、参照との違いは何ですか>))
* ((<FAQ::組み込みライブラリ/7.5 (({nil}))と(({false}))はどう違いますか>))
* ((<FAQ::組み込みライブラリ/7.6 ファイルを読み込んで書き換えても変化しません>))
* ((<FAQ::組み込みライブラリ/7.7 同じ名前のファイルに書き戻したいのですが>))
* ((<FAQ::組み込みライブラリ/7.8 ファイルに書き込んでそのファイルをコピーしましたが、全部コピーされません>))
* ((<FAQ::組み込みライブラリ/7.9 パイプで(({less}))に文字列を渡したのですが、表示されません>))
* ((<FAQ::組み込みライブラリ/7.10 参照されない(({File}))オブジェクトはどうなりますか>))
* ((<FAQ::組み込みライブラリ/7.11 ファイルを(({close}))しないのは気持ちが悪いのですが>))
* ((<FAQ::組み込みライブラリ/7.12 ファイルを時間の新しい順にソートしたいのですが>))
* ((<FAQ::組み込みライブラリ/7.13 ファイル中の単語の出現頻度を調べたいのですが>))
* ((<FAQ::組み込みライブラリ/7.14 条件に文字列を使ったとき、文字列が空("")の時にも(({true}))になります>))
* ((<FAQ::組み込みライブラリ/7.15 英語文字列の配列を辞書順にソートしたいのですが>))
* ((<FAQ::組み込みライブラリ/7.16 (({"abcd"[0]}))は、何を返しますか>))
* ((<FAQ::組み込みライブラリ/7.17 タブをスペースに展開したいのですが>))
* ((<FAQ::組み込みライブラリ/7.18 バックスラッシュをエスケープするにはどうしますか>))
* ((<FAQ::組み込みライブラリ/7.19 (({sub}))と(({sub!}))はどう違うのですか>))
* ((<FAQ::組み込みライブラリ/7.20 \Zのマッチする場所はどこですか>))
* ((<FAQ::組み込みライブラリ/7.21 範囲オブジェクトのコンストラクタ(({..}))と(({...}))はどう違いますか>))
* ((<FAQ::組み込みライブラリ/7.22 関数ポインタはありますか>))
* ((<FAQ::組み込みライブラリ/7.23 スレッドとプロセスのフォークはどう使い分けるのですか>))
* ((<FAQ::組み込みライブラリ/7.24 Marshalの使い方を教えてください>))
* ((<FAQ::組み込みライブラリ/7.25 例外処理はありますか>))
* ((<FAQ::組み込みライブラリ/7.26 (({trap}))はどのように使いますか>))
* ((<FAQ::組み込みライブラリ/7.27 ファイルの行数を数えたいのですが>))
* ((<FAQ::組み込みライブラリ/7.28 配列からハッシュへの変換はどうすればできますか>))
* ((<FAQ::組み込みライブラリ/7.29 文字列からArrayを作るのは %w(...) でできますが、同じように文字列からHashを作るにはどうすればよいですか>))
* ((<FAQ::組み込みライブラリ/7.30 例外 NameError が捕捉できません>))
* ((<FAQ::組み込みライブラリ/7.31 succがあってprevがないのはなぜですか>))

== 拡張ライブラリ

* ((<FAQ::拡張ライブラリ/8.1 Rubyを対話型で使いたいのですが>))
* ((<FAQ::拡張ライブラリ/8.2 デバッガはありますか>))
* ((<FAQ::拡張ライブラリ/8.3 C言語で書かれたライブラリをRubyで使いたいのですが>))
* ((<FAQ::拡張ライブラリ/"8.4 Tcl/Tkのインターフェースはありますか">))
* ((<FAQ::拡張ライブラリ/8.5 Tkが動かないのですが>))
* ((<FAQ::拡張ライブラリ/8.6 gtk+、xformsのインターフェースはありますか>))
* ((<FAQ::拡張ライブラリ/8.7 日付の計算をしたいのですが>))

== ドキュメントされていない機能

== 日本語の取り扱い

* ((<FAQ::日本語の取り扱い/10.1 漢字を含んだスクリプトが文字化けを出力したり、正しく実行できない場合があります>))
* ((<FAQ::日本語の取り扱い/10.2 オプション(({-K})) と (({$KCODE})) の違いはなんですか？>))
* ((<FAQ::日本語の取り扱い/10.3 日本語の識別子は使えますか>))
* ((<FAQ::日本語の取り扱い/10.4 日本語を含む文字列から1文字ずつ文字列を取り出すにはどうしますか>))
* ((<FAQ::日本語の取り扱い/10.5 tr("あ","a")がうまく動きません>))
* ((<FAQ::日本語の取り扱い/10.6 ひらがなをソートするにはどうしますか>))
* ((<FAQ::日本語の取り扱い/10.7 SJISの機種依存コード84BF から 889Fまでを空白に置き換えたいのですが>))
* ((<FAQ::日本語の取り扱い/10.8 いわゆる全角文字と半角文字の変換を行うにはどうするのがよいですか？>))
* ((<FAQ::日本語の取り扱い/10.9 いわゆる半角カナの扱い>))
* ((<FAQ::日本語の取り扱い/10.10 日本語を含む文字列から n バイトを切り出したいのですが>))
* ((<FAQ::日本語の取り扱い/10.11 日本語テキストを n 桁で折り返したいのですが>))

== Ruby の処理系について

* ((<FAQ::Rubyの処理系について/11.1 Ruby スクリプトをコンパイルすることはできますか？>))
* ((<FAQ::Rubyの処理系について/11.2 Java VM 上で動く Ruby ってありますか？>))
* ((<FAQ::Rubyの処理系について/11.3 オリジナル以外の Ruby の実装はありますか？>))
* ((<FAQ::Rubyの処理系について/11.4 Ruby 用の indent みたいなものはありますか？>))
* ((<FAQ::Rubyの処理系について/11.5 ネイティブスレッドを使った Ruby はない？>))
* ((<FAQ::Rubyの処理系について/11.6 GC が遅い！ どうにかならないの？>))
* ((<FAQ::Rubyの処理系について/11.7 Mac では Ruby は動かないの？>))
