= fatal

インタプリタ内部で致命的なエラーが起こったときに発生します。
致命的なエラーとは、例えば以下のような状態です。

  * スレッドのデッドロックが発生した
  * ((|-x|)) オプションや ((|-C|)) オプションで指定された
    ディレクトリに chdir できなかった
  * ((<Rubyの起動/-i[extension]>)) オプション付きで起動されたが、
    パーミッションなどの関係でファイルを変更できなかった

通常 Ruby プログラムからは (({fatal})) オブジェクトは見えません。

# 以下のようにすれば見えます
#
#    begin
#      Thread.start { Thread.stop }
#      Thread.stop
#    rescue Exception
#      Fatal = $!.class
#    end
#
#    p Fatal    # => fatal

== スーパークラス:

* ((<Exception>))
