= parsearg.rb

                                    Author: <jammy@shljapan.co.jp>

オプションを解析し，`$OPT_xxx'に値を設定します．更に指定したオプシ
ョンが条件にあっていない場合，USAGE を表示します．

== 使用しているライブラリ:

* ((<getopts.rb>))

== 書式:

--- parseArgs(MIN_ARGC，CHECH_OPTS，SINGLE_OPTS，*OPTS)

: 第一引数:
  `-'や`--'を伴って指定するオプション以外のオプションの最低必要数
  を指定します．存在しない場合は0を指定します．

: 第二引数:
  どのオプションが必要条件かを指定します．第三，第四引数で指定する
  オプションのうち必要なものを'('，')'，'|'，'&' を使って並べ，全
  体をダブルクォテーションで括ります． Rubyスクリプト実行時に全て
  のオプションが省略可能ならば `nil'を指定して下さい．
  以下の例では，"-d" と最低でも "-x"，"-y"，"--geometry"のど
  れか一つが実行時に必要なオプションとなります．
  `parseArgs(0，"d&(x|y|geometry)"，"fd"，"x:"，"y:"，"geometry:"，"version")'

: 第三，第四引数:
  ((<getopts.rb/getopts>)) の第一，第二引数と同じです．

== オプション解析:

((<getopts.rb/getopts>)) のオプション解析と同じです．

== USAGEの設定:

`$USAGE'に`usage()'(名前は何でもよい)をセットします．

        def usage()
          printf("Usage:\n")
                :
        end
        $USAGE='usage'

== 参照:

* ((<"ruby-src:sample/getopts.test">))

* ((<"ruby-src:sample/biorhythm.rb">))
